local memory = require 'memory'

function main()
  repeat wait(0) until isSampAvailable()
  setupStamina()
  while true do
    updateStamina(getSprintLocalPlayer())
    wait(1000)
  end
end

function onReceivePacket(id, bs)
  if id == 220 then
    raknetBitStreamReadInt8(bs)
    if raknetBitStreamReadInt8(bs) == 17 then
      raknetBitStreamReadInt32(bs)
      local text = raknetBitStreamReadString(bs, raknetBitStreamReadInt32(bs));
      local event, data = text:match('window%.executeEvent%(\'([%w.]+)\',%s*\'(.+)\'%)');
      if event == 'event.hudSA.updateSanAndreasHudVisible' and data == '[true]' then
        setupStamina()
      end
    end
  end
end

function setupStamina()
  evalanon [[
    // remove old indicator
    if (document.getElementById('arzaddon__hud__stamina')) document.getElementById('arzaddon__hud__stamina').remove();

    // get indicators div and other elements
    const indicators = document.querySelector('.arizona-hud__player-info > .player-info > .player-info__params > .player-info__indicators');
    if (!indicators) return;
    const randomIndicatorEl = indicators.querySelector('.circle-indicator');
    const randomIndicatorLinesEl = randomIndicatorEl?.querySelector('.circle-indicator__lines');
    if (!randomIndicatorEl || !randomIndicatorLinesEl) return;

    const circleIndicator_lines = randomIndicatorLinesEl.cloneNode(true); // clone indicator lines

    // vars
    const svgWidth = parseInt(getComputedStyle(randomIndicatorEl).getPropertyValue('--svg-width'));
    const dashArray = circleIndicator_lines.querySelector('.circle-indicator__svg-zone').style.getPropertyValue('--dasharray');
    const iconSize = svgWidth * 0.32 + 'px';
    const iconSvgSize = svgWidth * 0.36;

    const playerInfo_indicator = document.createElement('div'); {
      playerInfo_indicator.id = 'arzaddon__hud__stamina';
      playerInfo_indicator.classList.add('player-info__indicator');
    };
    const circleIndicator = document.createElement('div'); {
      circleIndicator.style = `--svg-width: ${svgWidth}px; --icon-color: #00b62d`;
      circleIndicator.classList.add('circle-indicator');  
    };
    const circleIndicator_light = document.createElement('div'); {
      circleIndicator_light.classList.add('circle-indicator__light');
    };

    const circleIndicator_icon = document.createElement('i'); {
      const circleIndicator_icon_wtf = document.createElement('svg');
      circleIndicator_icon.append(circleIndicator_icon_wtf)
      
      circleIndicator_icon.style.display = 'flex';
      circleIndicator_icon.style.alignItems = 'flex-start';
      circleIndicator_icon.style.justifyContent = 'center';
      circleIndicator_icon.style.width = iconSize;
      circleIndicator_icon.style.height = iconSize;
      circleIndicator_icon.classList.add('circle-indicator__icon');
      
      circleIndicator_icon_wtf.innerHTML = `<svg xmlns="http://www.w3.org/2000/svg" class="icon icon-tabler icon-tabler-run" width="${iconSvgSize}" height="${iconSvgSize}" viewBox="0 0 24 24" stroke-width="2" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round">
        <path stroke="none" d="M0 0h24v24H0z" fill="none"></path>
        <path d="M13 4m-1 0a1 1 0 1 0 2 0a1 1 0 1 0 -2 0"></path>
        <path d="M4 17l5 1l.75 -1.5"></path>
        <path d="M15 21l0 -4l-4 -3l1 -6"></path>
        <path d="M7 12l0 -3l5 -1l3 3l3 1"></path>
      </svg>`;
    };

    const circleIndicator_waveIcon = document.createElement('i'); {
      circleIndicator_waveIcon.classList.add('circle-indicator__wave-icon', 'ui-wave');
    };

    const circleIndicator_count = document.createElement('p'); {
      circleIndicator_count.textContent = window.arzaddon__hud__stamina__value ?? '0';
      circleIndicator_count.classList.add('circle-indicator__count');
    };

    circleIndicator.append(
      circleIndicator_lines,
      circleIndicator_light,
      circleIndicator_icon,
      circleIndicator_waveIcon,
      circleIndicator_count,
    );
    playerInfo_indicator.append(circleIndicator);
    indicators.append(playerInfo_indicator);

    window.arzaddon__hud__staminasvgzone__update = () => {
      const svgzone = circleIndicator_lines.querySelector('.circle-indicator__svg-zone');
      if (!svgzone) return;
      let n = +circleIndicator_count.textContent;
      const p = n < 0 ? 1 : n > 100 ? 0 : 1-(n/100);
      const v = parseInt(dashArray) * p;
      svgzone.style.setProperty('--dashoffset', v);
    };
    window.arzaddon__hud__staminasvgzone__update();
  ]]
end

function updateStamina(value)
  evalanon(([[
    window.arzaddon__hud__stamina__value = "%s";
    const el = document.querySelector('#arzaddon__hud__stamina .circle-indicator__count');
    if (!el || !window.arzaddon__hud__stamina__value || el.textContent === window.arzaddon__hud__stamina__value) return;
    el.textContent = window.arzaddon__hud__stamina__value;
    if (window.arzaddon__hud__staminasvgzone__update)
      window.arzaddon__hud__staminasvgzone__update();
  ]]):format(value))
end

function evalanon(code)
  evalcef(("(() => {%s})()"):format(code))
end

function evalcef(code)
  local bs = raknetNewBitStream()
  raknetBitStreamWriteInt8(bs, 17)
  raknetBitStreamWriteInt32(bs, 0)
  raknetBitStreamWriteInt32(bs, string.len(code))
  raknetBitStreamWriteString(bs, code)
  raknetEmulPacketReceiveBitStream(220, bs)
  raknetDeleteBitStream(bs)
end

function getSprintLocalPlayer()
  local float = memory.getfloat(0xB7CDB4)
  return math.floor(float/31.47000244)
end